[![Build Status](https://travis-ci.org/aschleg/mathpy.svg?branch=master)](https://travis-ci.org/aschleg/mathpy)

## About mathpy

mathpy is a collection of mathematical and statistical functions encompassing several different
fields such as linear algebra, numerical analysis, and number theory. The package is intended to
work with other popular scientific computing packages such as numpy and scipy. Most functions in
The mathpy package are also available as Excel UDFs for users who prefer working in Excel. The
mathpy project is primarily a personal project intended to develop a deeper understanding of
the mathematics and algorithmic implementations of various mathematical topics.

## Documentation

The documentation of the mathpy package is available here:

https://aschleg.github.io/mathpy/

The documentation for importing the mathpy functions to use in Excel as UDFs is found here:

https://aschleg.github.io/mathpy/excel.html

## Installation Requirements

* Python 2.7 or 3+
    - Recommended to install the Anaconda distribution for your preferred version of Python if not installed already.
* Compatible with Windows, Mac and Linux OS.
    - Excel UDFs are currently available in Windows only.

## Available Methods

* Linear Algebra
    - Matrix Decomposition
    - Vector and Matrix Norms
    - Matrix Tests

* Numerical Analysis
    - Polynomial Evaluation
    - Roots of Polynomials

* Number Theory
    - Binomial Coefficient
    - Factorials
    - Integer Factorization
    - Greatest Common Divisor
    - Prime Numbers
    - Number Sequences

* Statistics
    - Variance
    - Simulating Correlation Matrices

### License

MIT
